extern ISR_DefaultInterrupt, ISR_GPExec, ISR_PFExec, ISR_ClockInterrupt, ISR_KeyboardInterrupt, ISR_SystemCalls
global ASM_DefaultInt, ASM_ExecGP, ASM_ExecPF, ASM_IRQ0, ASM_IRQ1, ASM_SystemCalls

%macro	SAVE_REGS 0
	pushad 
	push ds
	push es
	push fs
	push gs 
	push ebx
	mov bx,0x10
	mov ds,bx
	pop ebx
%endmacro

%macro	RESTORE_REGS 0
	pop gs
	pop fs
	pop es
	pop ds
	popad
%endmacro

ASM_DefaultInt:
	SAVE_REGS
	call ISR_DefaultInterrupt
	RESTORE_REGS
	mov al,0x20
	out 0x20,al
	iret

ASM_ExecGP:
	SAVE_REGS
	call ISR_GPExec
	RESTORE_REGS
	add esp,4
	iret

ASM_ExecPF:
	SAVE_REGS
	call ISR_PFExec
	RESTORE_REGS
	add esp,4
	iret

ASM_IRQ0:
	SAVE_REGS
	call ISR_ClockInterrupt
	RESTORE_REGS
	mov al,0x20
	out 0x20,al
;spin:
;;  sti   ; STI is a must have, else we will have no IRQ ...
;;  hlt
;  jmp short spin
;spin:
;  hlt
;  jmp short spin
	iret

ASM_IRQ1:
	SAVE_REGS
	call ISR_KeyboardInterrupt
	RESTORE_REGS
	mov al,0x20
	out 0x20,al
	iret

ASM_SystemCalls:
	SAVE_REGS
	push eax                 ; transmission du numero d'appel
	call ISR_SystemCalls
	pop eax
	RESTORE_REGS
	iret
