// PIC => 8259
#include "includes/ProgrammableInterruptController.hpp"
#include "../includes/asm.hpp"

namespace BootProcess
{
  namespace ProgrammableInterruptController
  {
    void Init()
    {
      //  ICW1 Init
      ASM::OUTB(0x20, 0x11);
      ASM::OUTB(0xA0, 0x11);

      //  ICW2 Init
      ASM::OUTB(0x21, 0x20);  //  Starting vector 32
      ASM::OUTB(0xA1, 0x70);  //  Starting vector 96

      //  ICW3 Init
      ASM::OUTB(0x21, 0x04);
      ASM::OUTB(0xA1, 0x02);

      //  ICW4 Init
      ASM::OUTB(0x21, 0x01);
      ASM::OUTB(0xA1, 0x01);

      //  Mask interrupts
      ASM::OUTB(0x21, 0x00);
      ASM::OUTB(0xA1, 0x00);
    }
  }
}
