#include "../../includes/types.hpp"

namespace BootProcess
{
  namespace InterruptDescriptorTable
  {
    #ifndef __KERNEL_BOOTPROCESS_INCLUDES_INTERRUPTDESCRIPTORTABLE_HPP__
    #define __KERNEL_BOOTPROCESS_INCLUDES_INTERRUPTDESCRIPTORTABLE_HPP__

      struct Descriptor
      {
      	u16 Offset_0_15;
      	u16 Select;
      	u16 Type;
      	u16 Offset_16_31;
      } __attribute__ ((packed));
      
      /* Registre IDTR */
      struct Register
      {
      	u16 Limit;
      	u32 Base;
      } __attribute__ ((packed));

    #endif

    void Init(void);
    void InitDescriptor(u16 select, u32 offset, u16 type, struct Descriptor *desc);
  }
}
