#include "../../includes/types.hpp"
//#include <stdargs.h>

namespace BootProcess
{
  namespace Screen
  {
    #ifndef __KERNEL_BOOTPROCESS_INCLUDES_SCREEN_HPP__
    #define __KERNEL_BOOTPROCESS_INCLUDES_SCREEN_HPP__

      extern s8 X;
      extern s8 Y;
      extern s8 Attributes;

    #else


    #endif

    void ScrollUp(u32 lines);
    void PrintCharacter(s8 character);
    void PrintCharacterXY(s8 character, s8 x, s8 y);
    void Print(s8* string);
    void PrintXY(s8* string, s8 x, s8 y);
    void Clear();
    void ClearWithColor(s8 attributes);
    void MoveCursor(u8 x, u8 y);
    void ShowCursor();
    void HideCursor();
    void PrintFormat(s8* s, ...);

    //  Used for '...' parameter
    #ifndef _VA_LIST_DEFINED
    #define _VA_LIST_DEFINED

      typedef char *va_list;

      #define _INTSIZEOF(n)    ((sizeof(n) + sizeof(int) - 1) & ~(sizeof(int) - 1))
      
      #define va_start(ap, v)  (ap = (va_list) &v + _INTSIZEOF(v))
      #define va_arg(ap, t)    (*(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)))
      #define va_end(ap)       (ap = (va_list) 0)
    
    #endif

    void itoa(s8 *buf, unsigned long int n, int base);
    int strlen(s8* s);
  }
}
