#include "types.hpp"
#include "VirtualMemoryManager.hpp"

namespace Processes
{
  #ifndef __KERNEL_INCLUDES_PROCESSES_HPP__
  #define __KERNEL_INCLUDES_PROCESSES_HPP__

    struct Process
    {
      s32 ID;
  
      struct
      {
        u32 eax, ecx, edx, ebx;
        u32 esp, ebp, esi, edi;
        u32 eip, eflags;
        u32 cs:16, ss:16, ds:16, es:16, fs:16, gs:16;
        u32 cr3;
      }__attribute__((packed)) Registers;
  
      struct
      {
        u32 esp0;
        u16 ss0;
      }__attribute__((packed)) KernelStack;
  
      struct VirtualMemoryManager::PageDirectory* PageDirectory;

      s32 State;
    }__attribute__((packed));

    extern struct Process List[];
    extern struct Process* Current;
    extern s32 Count;

  #endif

  int LoadTask(s8*, u32);
}
