#include "types.hpp"

namespace ASM
{
  inline void HLT()
  {
    asm volatile("hlt");
  }

  inline void CLI()
  {
    asm volatile("cli");
  }

  inline void STI()
  {
    asm volatile("sti");
  }

  inline void OUTB(u16 port, u8 value)
  {
    asm volatile("outb %%al, %%dx" :: "d"(port), "a"(value));
  }

  inline u8 INB(u16 port)
  {
    u8 ret;

    asm volatile("inb %%dx, %%al" : "=a"(ret) : "d"(port));

    return ret;
  }

  inline void OUTW(u16 port, u16 value)
  {
    asm volatile("outw %%ax, %%dx" :: "d"(port), "a"(value));
  }

  inline u16 INW(u16 port)
  {
    u16 ret;

    asm volatile("inw %%dx, %%ax" : "=a"(ret) : "d"(port));

    return ret;
  }

  inline void OUTL(u16 port, u32 value)
  {
    asm volatile("outl %%eax, %%dx" :: "d"(port), "a"(value));
  }

  inline u32 INL(u16 port)
  {
    u32 ret;

    asm volatile("inl %%dx, %%eax" : "=a"(ret) : "d"(port));

    return ret;
  }
}